﻿using Kingdee.BOS.Core.Report.PlugIn;
using Kingdee.BOS.Core.Report.PlugIn.Args;
using Kingdee.BOS.Util;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace TenderItem.Induct
{
    [Description("【报表表单插件】投标项目报表"), HotUpdate]
    public class TenderFormServicePlugIn: AbstractSysReportPlugIn
    {
        public override void FormatCellValue(FormatCellValueArgs args)
        {
            // 格式化日期
            base.FormatCellValue(args);
            if (args.Header.ColType == Kingdee.BOS.SqlStorageType.SqlDatetime)
            {
                DateTime value = Convert.ToDateTime(args.FormateValue);
                string afterValue = value.ToString("yyyy-MM-dd");
                args.FormateValue = afterValue;
            }
            // 格式化金额  汇率不格式化
            if (args.Header.ColType == Kingdee.BOS.SqlStorageType.SqlDecimal)
            {
                decimal value = decimal.Parse(args.FormateValue);
                // 千分位
                string afterValue = value.ToString("N");
                args.FormateValue = afterValue;
            }
        }
    }
}
